/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package org.isokissa.crowd.sim;

import org.isokissa.crowd.sim.drivers.Driver;
import org.isokissa.crowd.sim.lifecycle.Drain;
import org.isokissa.crowd.sim.lifecycle.PeriodicSpawner;
import org.isokissa.crowd.sim.lifecycle.Spawner;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.util.List;

import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

class ArenaTest {

    private Arena arena;

    private final float x = 5;
    private final float y = 105;


    @BeforeEach
    public void setup() {
        arena = new Arena();
    }

    @Test
    public void initiallyArenaHasNoBodies() {
        assertEquals(0, arena.getAllBodies().size());
    }

    @Test
    public void canAddBody() {
        Body body = new Body(1, 3);

        arena.add(body);

        assertEquals(1, arena.getAllBodies().size());
    }

    @Test
    public void getBodiesWithAreaAwayFromBodyDoesNotFindTheBody() {
        Body body = new Body(x, y);
        arena.add(body);

        List<PlaneBody> bodies = arena.getBodies(x + 1, x + 5, y - 1, y + 1);

        assertEquals(0, bodies.size());

        bodies = arena.getBodies(x - 1, x + 1, y + 1, y + 5);

        assertEquals(0, bodies.size());
    }

    @Test
    public void getBodiesWithAreaContainingBodyDoesFindTheBody() {
        Body body = new Body(x, y);
        arena.add(body);

        List<PlaneBody> bodies = arena.getBodies(x - 1, x + 1, y - 1, y + 1);

        assertEquals(1, bodies.size());
        assertEquals(x, bodies.get(0).getX());
        assertEquals(y, bodies.get(0).getY());
    }

    @Test
    public void advanceArenaWillAdvanceBodies() {
        final float seconds = 0.2f;
        Body body = new Body(x, y);
        Driver driverMock = mock(Driver.class);
        body.setDriver(driverMock);
        arena.add(body);

        arena.advance(seconds);

        verify(driverMock, times(1)).drive(body, seconds);
    }

    @Test
    public void advanceArenaWillAdvanceSpawnersAndItWillSpawnNewBody() {
        final float seconds = 2f;
        final float period = 3f;
        Spawner spawner = new PeriodicSpawner(100, 100, period,
                0, 0, () -> mock(Driver.class));
        arena.add(spawner);

        arena.advance(seconds);

        assertEquals(0, arena.getAllBodies().size(), "Spawner is not yet advanced");

        arena.advance(seconds);

        assertEquals(1, arena.getAllBodies().size(), "Now the spawner is advanced");
    }

    @Test
    public void advanceArenaWillAdvanceTheDrainAndBodyWhichIsInDrainWillBeRemoved() {
        float x = 100;
        float y = 50;
        float size = 5;
        Body bodyOutOfDrain = new Body(0, 0);
        Body bodyInDrain = new Body(x - size + 1, y);
        Drain drain = new Drain(x, y, size);
        arena.add(drain);
        arena.add(bodyOutOfDrain);
        arena.add(bodyInDrain);

        arena.advance(1);

        List<PlaneBody> remainingBodies = arena.getAllBodies();
        assertEquals(1, remainingBodies.size());
        PlaneBody theOnlyBody = remainingBodies.get(0);
        assertEquals(0, theOnlyBody.getX());
        assertEquals(0, theOnlyBody.getY());
    }

    @Test
    public void advanceWillMarkCollidedBodiesAndCollidedBodiesWillStop() {
        Body body1 = Utils.spyBody(0, 0, 0, 3);
        when(body1.getState()).thenReturn(PlaneBody.State.NORMAL);
        Body body2 = Utils.spyBody(0, 0, 0, 2);
        when(body2.getState()).thenReturn(PlaneBody.State.NORMAL);
        Body body3 = Utils.spyBody(5, 5, 0, 5);
        when(body3.getState()).thenReturn(PlaneBody.State.NORMAL);
        arena.add(body1);
        arena.add(body2);
        arena.add(body3);

        arena.advance(0.01f);

        verify(body1, times(1)).setState(PlaneBody.State.COLLIDED);
        verify(body2, times(1)).setState(PlaneBody.State.COLLIDED);
        assertEquals(PlaneBody.State.NORMAL, body3.getState());
    }

    @Test
    public void advanceWillNotMarkCollidedBodiesWhenTheyAreInvisible() {
        Body body1 = Utils.spyBody(0, 0, 0, 3);
        when(body1.getState()).thenReturn(PlaneBody.State.INVISIBLE);
        Body body2 = Utils.spyBody(0, 0, 0, 2);
        when(body2.getState()).thenReturn(PlaneBody.State.NORMAL);
        Body body3 = Utils.spyBody(5, 5, 0, 5);
        when(body3.getState()).thenReturn(PlaneBody.State.NORMAL);
        arena.add(body1);
        arena.add(body2);
        arena.add(body3);

        arena.advance(0.01f);

        verify(body1, times(0)).setState(any());
        verify(body2, times(0)).setState(any());
        verify(body3, times(0)).setState(any());
    }
}
